
#include "Get_Key.h"

int kbhit(void)
{
  int		  count = 0;
  int		  error;
  struct timespec tv;
  struct termios  otty, ntty;

  tcgetattr(STDIN_FILENO, &otty);
  ntty = otty;
  ntty.c_lflag 	 &= ~ICANON; /* raw mode */

  if (0 == (error = tcsetattr(STDIN_FILENO, TCSANOW, &ntty))) {
    error        += ioctl(STDIN_FILENO, FIONREAD, &count);
    error        += tcsetattr(STDIN_FILENO, TCSANOW, &otty);
    /* minimal delay gives up cpu time slice,
     * allows use in a tight loop */
    tv.tv_sec     = 0;
    tv.tv_nsec    = 10;
    nanosleep(&tv, NULL);
  }

  return error == 0 ? count : -1;
}

int getch(void)
{
  unsigned char		ch;
  int			error;
  struct termios	otty, ntty;

  fflush(stdout);
  tcgetattr(STDIN_FILENO, &otty);
  ntty = otty;

  ntty.c_lflag &= ~ICANON;   /* line settings    */

#if 1
  /* disable echoing the char as it is typed */
  ntty.c_lflag &= ~ECHO;     /* disable echo 	 */
#else
  /* enable echoing the char as it is typed */
  ntty.c_lflag |=  ECHO;     /* enable echo	 */
#endif

  ntty.c_cc[VMIN]  = 1;      /* block for input  */
  ntty.c_cc[VTIME] = 0;      /* timer is ignored */

#if 1
/*
 * use this to flush the input buffer before
 * blocking for new input
 */
#define FLAG TCSAFLUSH
#else
/*
 * use this to return a char from the current input
 *  buffer, or block if no input is waiting.
 */
#define FLAG TCSANOW

#endif

 if (0 == (error = tcsetattr(STDIN_FILENO, FLAG, &ntty))) {
   /* get a single character from stdin */
   error  = read(STDIN_FILENO, &ch, 1 );
   /* restore old settings */
   error += tcsetattr(STDIN_FILENO, FLAG, &otty); 
  }

  return (error == 1 ? (int) ch : -1 );
}
