#ifndef PACKETBUFFER_H
#define PACKETBUFFER_H

#include <SDL_net.h>

#define MAX_BUFF 10

class Packet_Buffer
{
  public:
    Packet_Buffer();                   //sets top to -1 and all that good stuff
    ~Packet_Buffer();
    bool isEmpty() const;              //checks to see if the stack is empty
    void push(UDPpacket**);            //adds a packet vector to the top of the stack
    UDPpacket* pop();                 //returns top of stack and removes it
    UDPpacket* handle_oldest();       //throws back the bottom of the stack (testing)
    
  private:
    int top;                           //keeps track of top of stack
    int numPushs, numPops;             //used in math to find bottom. (currently will cause overflow at 32k push/pop calls) (TESTING!)
    UDPpacket *p_out_stack[MAX_BUFF];
};

#endif
