/*

  Code is getting a bit jumbly. Need to update the client software so I can send a vector of
  packets at once. I want the client to send "command msg" "ip address" and "open port" to the
  server software so it knows how to respond correctly. I'm too tired to do it now so I'll just
  do it tomorrow morning probably.
  
  Func prototypes needed:
  ------------------------
    UDPpacket** SDLNet_AllocPacketV(int howmany, int size);                     - allocate it
    void SDLNet_FreePacketV(UDPpacket **packetV);                               - free it
    int SDLNet_UDP_SendV(UDPsocket sock, UDPpacket **packets, int npackets);    - send it
    int SDLNet_UDP_RecvV(UDPsocket sock, UDPpacket **packets);                  - recieve it
    
    
  Also need to put incoming packets into a stack buffer so that they won't be lost when another
  packet comes in. 
  
    ->"reply()" needs to be written to check to see if there's items on the bottom of the buffer (send them in order)
      and if isEmpty() == false read oldest packet info and reply to it. Keep doing this until the
      buffer is empty.
      
    ->New packets that come in get throw to the top, not handled right away.
*/




// UDP_Server_Service class implementation file

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "UDP_Server_Service.h"
#include <unistd.h>

UDP_Server_Service::UDP_Server_Service(int listen_port)
{
  chan = -1;
  destination_ip = "0";
  destination_port = 9999;

  if (listen_port != 0)
    printf("Accepting connections on port: %d\n", listen_port);
  
  else
  {
    listen_port = 4555;
    printf("\nNo port given...\nDefaulting to port 4555...\n");
  }
  
  printf("Initializing SDL_net (recieve)...");  
  if (SDLNet_Init() < 0)    //init sdl_net
  {
    fprintf(stderr, "FAILED!\nSDLNet_Init: %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");
  
  // open socket on port given
  
  printf("Opening port %d for incoming connections...", listen_port);
  if (!(sd_recieve = SDLNet_UDP_Open(listen_port)))
  {
    fprintf(stderr, "FAILED!\nSDLNet_UDP_Open(port): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");

  //open socket on random port for sending data out
  printf("Opening random communication socket for sending...");
  if (!(sd_send = SDLNet_UDP_Open(0)))
  {
    fprintf(stderr, "FAILED!\nSDLNet_UDP_Open(0): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");

  
  //init destination address
  resolve_dest_address();
  
  //allocate memory for outbound packets (3 packets at the size of 512 bytes)
  printf("Allocating memory for sending packets...");
  if (!(p_send = SDLNet_AllocPacketV(3, 512)))
  {
    fprintf(stderr, "FAILED!\nSDLNet_AllocPacket(512): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");

  
  // allocate space for the inbound packet
  printf("Allocating memory for recieving packets...");
  if (!(p_recieve = SDLNet_AllocPacketV(3, 512)))
  {
    fprintf(stderr, "FAILED!\nSDLNet_AllocPacket(512): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n\n");
}

UDP_Server_Service::~UDP_Server_Service()
{
    //close sockets.
    SDLNet_UDP_Close(sd_send);
    SDLNet_UDP_Close(sd_recieve);
    printf("Shutting down sending client...\n");
    printf("Freeing allocated memory for outbound packets...");
    //SDLNet_FreePacketV(p_send);
    printf("Done!\nShutting down recieving client...\n");
    printf("Freeing allocated memory for inbound packets...");        
    SDLNet_FreePacketV(p_recieve);
    printf("Done!\nExiting SDLNet and terminating server...");
    SDLNet_Quit();
    printf("Done!\n");
    
}

void UDP_Server_Service::send_update(char *message, UDPpacket **client_address)
{
//   SDLNet_ResolveIP(&client_address->address);
   //fill and send the packet



//    IPaddress *desti = new IPaddress;
//    desti = SDLNet_UDP_GetPeerAddress(sd_recieve, chan);
    
//    (char *)p_send[0]->data = message;
    p_send[0]->data = (Uint8*) message;
    
    //set destination host & port
//    p_send->address = *desti;

    
    printf("SENDING!\n");
    printf("IP: %d\nport: %d\n", client_address[0]->address.host, client_address[0]->address.port);
    //calculate length of data string
    p_send[0]->len = strlen((char *)p_send[0]->data) + 1;

    if (SDLNet_ResolveHost(&p_send[0]->address, "192.168.1.104", 4567))
      printf("\nError re-resolving host!\n");
    
    //send the packet
    SDLNet_UDP_SendV(sd_send, p_send, 3);
    
 //   delete desti;
    
}

void UDP_Server_Service::reply()
{

}
  
int UDP_Server_Service::recieve_data(void)
{
 // bool inner_wait = true;

  if (SDLNet_UDP_RecvV(sd_recieve, p_recieve))
  {
    printf("Packet array incoming!\n");

	/* 04-04-18 - Fixing this so it doesn't seg fault.
    printf("\t  IP: %s\n", (char *)(SDLNet_Read32(p_recieve[IP]->data)));
    printf("\tPORT: %s\n", p_recieve[PORT]->data);
    printf("\t MSG: %s\n", p_recieve[MSG]->data);
	*/

	printf("\t  IP: %s\n", p_recieve[IP]->data);
	printf("\tPORT: %s\n", p_recieve[PORT]->data);
	printf("\t MSG: %s\n", p_recieve[MSG]->data);

    //if they sent the quit command
    if (!strcmp((char *)p_recieve[MSG]->data, "quit"))
    {
      //system("clear"); //04-04-18 - don't clear screen.
      printf("\nServer recieved \"quit\" signal from client!\n");
      return 0;
    }
/*    
    if (!strcmp((char *)p_recieve[MSG]->data, "update"))
    {
      printf("Recieved update request from client... redirecting and sending information...\n");
      while (inner_wait)
      {
        if (SDLNet_UDP_RecvV(sd_recieve, p_recieve))
	{
          send_data((char *)p_recieve[0]->data, p_recieve);
	  inner_wait = false;
	}
      }
	  
    }
*/

	/* 04-04-18 - messing around with getting update command basics */

    if (!strcmp((char *)p_recieve[MSG]->data, "update")) {

		int MAX_PACKETS = 3;
		printf("Recieved update request from client... redirecting and sending information...\n");

		p_send[IP]->data = p_recieve[IP]->data;
		p_send[PORT]->data = p_recieve[PORT]->data;
		p_send[MSG]->data = (Uint8*)"up_resp";

		IPaddress client_address;
		char *clientIp = "127.0.0.1";
		Uint16 clientPort = 4556;

		if ((SDLNet_ResolveHost(&client_address, clientIp, clientPort)) != 0) {
			fprintf(stderr, "FAILED!\nSDLNet_ResolveHost(%s %d): %s\n", clientIp, clientPort, SDLNet_GetError());
		}
	    else {  //send update packet 
			usleep(1000);
			printf("ip: %d\n", p_recieve[IP]->address.host);
			printf("host: %d\n", p_recieve[IP]->address.port);

			//set destination host & port
			printf("Setting packet vector destination info...\n");
  		  	for (int i = 0; i < MAX_PACKETS; i++) {    
				printf("Packet[%d]: setting host->", i);			    
			    printf("setting port->");
				p_send[i]->address = client_address;
			    printf("setting length->");
			    p_send[i]->len = sizeof(p_send[i]->data) + 1; 
			    printf("%d setting channel...\n", p_send[i]->len);
			    p_send[i]->channel = -1;
			}

	    	//send the packet
			printf("Sending...\n");
    		if((SDLNet_UDP_SendV(sd_send, p_send, MAX_PACKETS)) == -1)  //socket, packet, # of packets.
				printf("Error sending packet!\n");
		
		    printf("Update request complete.\n");
		}
    }

  }
  
  return 1;
}

void UDP_Server_Service::resolve_dest_address(void)
{
  
  printf("Resolving destination address...");
  if (SDLNet_ResolveHost(&destadd, NULL, destination_port))
  {
    fprintf(stderr, "FAILED!\nSDLNet_ResolveHost(%s %d): %s\n", destination_ip, destination_port, SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");
}

int UDP_Server_Service::resolve_dest_address(char *new_dest_ip)
{
  destination_ip = new_dest_ip;
  
  printf("Resolving new destination IP @ %s on port %d...", destination_ip, destination_port);
  if (SDLNet_ResolveHost(&destadd, destination_ip, destination_port))
  {
    fprintf(stderr, "FAILED!\nSDLNet_ResolveHost(%s %d): %s\n", destination_ip, destination_port, SDLNet_GetError());
    return 0;
  }
  printf("Success!\n");
  
  return 1;
}

int UDP_Server_Service::resolve_dest_address(int new_dest_port)
{
  destination_port = new_dest_port;
  
  printf("Setting destination port %d @ %s...", destination_port, destination_ip);
  if (SDLNet_ResolveHost(&destadd, destination_ip, destination_port))
  {
    fprintf(stderr, "FAILED!\nSDLNet_ResolveHost(%s %d): %s\n", destination_ip, destination_port, SDLNet_GetError());
    return 0;
  }
  printf("Success!\n");
  return 1;
}

void UDP_Server_Service::show_dest_info(void) const
{
  printf("Sending packets to %s on port %d\n", destination_ip, destination_port);
}
