#ifndef UDP_SERVER_SERVICE_H
#define UDP_SERVER_SERVICE_H

// server object header file

#include <SDL_net.h>

#define IP 0
#define PORT 1
#define MSG 2

class UDP_Server_Service
{
  public:
    UDP_Server_Service(int);         //recieves port number to open (server)
    ~UDP_Server_Service();  
    void send_update(char*, UDPpacket**);              //send data to currently set dest IP at currently set port #
    void reply();                       //replies to oldest message in packet buffer stack.
    int recieve_data(void);             //scan for packets sent to server
    int resolve_dest_address(char*);    //sets new destination IP & re-resolves host
    int resolve_dest_address(int);      //sets new destination port & re-resolves host
    void show_dest_info(void) const;    //displays packet destination information.
    
  private:
    void resolve_dest_address(void);  //used during initialization to init variables.
    
    UDPsocket sd_send;           //socket descriptor for sending 
    UDPsocket sd_recieve;        //socket descriptor for recieving 
    UDPpacket **p_send;           //packet to be sent (data sent to clients)
    UDPpacket **p_recieve;        //packet data pointer to recieved info (server recieve from clients)
    IPaddress destadd;           //destinations ip address
    
    char *destination_ip;       //destination IP used for redirecting packet traffic
    int destination_port;       //same as above but with the destination port.    
    int chan;
    

    
};
  
#endif
